unit I2Cdb;
{Komunikace po I2C

LPT:
SDA - Strobe (1) , bit 0, neg.
SCL - (14) , bit 1, neg.
GND - GND (25)
}

{* Unita se zaklada na zdroj. kodu uverejnenem v AR *}
{* v ramci serialu Male automatizace.               *}
{*                                                  *}
{* Je upravena pro pouziti jen LPT, byly opraveny   *}
{* nektere chyby (cekani na SCL, chybici Delay),    *}
{* pridano nacitani konstanty Delay z konf. souboru,*}
{* byl proveden port z Pascalu do Delphi            *}
{*                                                  *}
{* Tato unita zapouzdruje celou komunikaci s HW -   *}
{* jeji nahradou je mozne upravit SW napr. na provoz*}
{* pres COM port nebo pres RS 232                   *}

interface
const T=true;
      F=false;

var TimeDelay:longint;

type TI2C=object

 {ZAPIS: Start/Send(devaddr)/Send(Addr)/Send(Data)/STOP}
 {CTENI: Start/Send(devaddr)/Send(Addr)/Receive(false)/Receive(true)/STOP}

 constructor Init(BASE:Longint);
  {base>0 - lpt, base<0 com}

 procedure SDA_OUT(D:boolean);
 procedure SCL_OUT(D:boolean);
 function SDA_IN:boolean;
 procedure Delay; virtual;
 function SCL_In:boolean;
 procedure Start;
 procedure Stop;
 procedure Pulse;
 function SEND(H:Byte):boolean;
 function RECEIVE(L:boolean):byte;
 function RECEIVE2(L:boolean):byte; {ceka pri podrzeni SCL}

 private
 BasePort:word;
 Tmp1,Tmp2:byte;

end;

implementation

uses ioport,sysutils;
var att:textfile;
    ats:string;

function ReadPort(Addr:word):byte;
begin
 readport:= inportb($37A);
end;
procedure WritePort(Addr:word;value:byte);
begin
 outportb($37A,value);
end;

constructor TI2C.Init;
begin
 Tmp1:=0;
 Tmp2:=ReadPort(BasePort+2);
 SCL_Out(F);
 SDA_Out(T);
end;

procedure TI2C.SCL_Out;
begin
 if D then Tmp2:=Tmp2 and (not 2) else
           Tmp2:=Tmp2 or 2;
 WritePort(BasePort+2,Tmp2);
 Delay;
end;

procedure TI2C.SDA_Out;
begin
 if D then Tmp2:=Tmp2 and (not 1) else
           Tmp2:=Tmp2 or 1;
 WritePort(BasePort+2,Tmp2);
 Delay;
end;

function TI2C.SDA_In;
begin
 delay;
 SDA_In:=(ReadPort(BasePort+2) and 1)=0;
end;

procedure TI2C.Start;
begin
 SDA_out(T);
 SCL_out(T);
 SDA_out(F);
 SCL_out(F);
end;

procedure TI2C.Stop;
begin
 SDA_out(F);
 SCL_out(T);
 SDA_out(T);
 SCL_out(F);
end;

procedure TI2C.Pulse;
begin
 SCL_out(T);
 SCL_out(F);
end;

function TI2C.Send;
var i:byte;
begin
 for i:=1 to 8 do begin
  SDA_out(H and $80>0);
  Pulse;
  H:=H shl 1;
 end;
 SDA_out(T);
 Send:=not SDA_in;
 Pulse;
end;

function TI2C.SCL_In;
begin
 TI2C.delay;
 SCL_In:=(ReadPort(BasePort+2) and 2)=0;
end;

function TI2C.Receive2;
var I,H:byte;w:word;
begin
 H:=0;
 SDA_Out(T);
 SCL_Out(T);
{ if not SCL_In then system.write('x');}
 w:=0;
 while not SCL_In do begin
  inc(w);
  delay;
 end;

 for i:=1 to 8 do begin
  H:=H shl 1;
  SCL_Out(T);
  if SDA_In then
   H:=H or 1;
  SCL_Out(F);
 end;
 delay;

 SDA_Out(L);

 Pulse;
 Receive2:=H;
end;

function TI2C.Receive;
var I,H:byte;
begin
 H:=0;
 SDA_Out(T);
 for i:=1 to 8 do begin
  H:=H shl 1;
  SCL_Out(T);
  if SDA_In then
   H:=H or 1;
  SCL_Out(F);
 end;
 SDA_Out(L);
 Pulse;
 Receive:=H;
end;

procedure TI2C.Delay;
var i:longint;
begin
 for i:=0 to timedelay do ;
end;

begin
 timedelay:=1600;
 //test otevreni konfiguracniho souboru pro TimeDelay
 assignfile(att,'I2C.cfg');
 {$I-}
  Reset(att);
  if ioresult=0 then begin
   //nacteme radek
   readln(att,ats);
   TimeDelay:=strtointdef(ats,1600);
  end;
  CloseFile(att);
 {$I+}
 ioresult;

end.

