unit UserTester;

interface

uses
  Windows, Messages, SysUtils, Classes;

type
  TUserTester = class(TComponent)
  private
    { Private declarations }
    lastbase:integer;
    procedure SetBase(value:integer);
    procedure SetWt(value:integer);
    function ReadWt:integer;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    property Base:integer read LastBase write SetBase default 0;
    property WaitTime:integer read ReadWt write SetWt;

    procedure Port(portd:boolean;data:byte);
    procedure Tris(portd:boolean;data:byte);
    function CtiPort(portd:boolean):byte;
    function AD256(nastav:byte):byte;
    function AD1024(nastav:byte):integer;
    procedure Send4094(str:boolean;data:byte);
    procedure SendDA(data:byte);
    function TestKomunikace:boolean;

    procedure About;
  end;

procedure Register;

implementation

uses I2Cdb,dialogs;
var a:TI2C;


procedure PosliPrikaz(module,data:byte);
begin
 a.Start;
 a.SEND($CA);
 a.SEND(module);
 a.send(data);
 a.stop;
end;

function TUserTester.TestKomunikace:boolean;
begin
 a.Start;
 result:=a.SEND($CA);
 a.stop;
end;

procedure PosliModul(module:byte);
begin
 a.Start;
 a.SEND($CA);
 a.send(module);
 a.stop;
end;

function Cti(module:byte;bool:boolean):byte;
begin
 a.Start;
 a.SEND($CA);
 a.SEND(module);
 a.stop;
 a.start;
 a.SEND($CA+1);
 cti:=a.RECEIVE2(bool);
 a.stop;
end;

function Cti1024(module:byte):integer;
begin
 a.Start;
 a.SEND($CA);
 a.SEND(module);
 a.stop;
 a.start;
 a.SEND($CA+1);
 result:=0;
 result:=a.RECEIVE2(false)*4;
 result:=a.RECEIVE2(true) div 64+result;
 a.stop;
end;



//implementace hlavnich ovladacich prikazu
procedure TUserTester.Port(portd:boolean;data:byte);
var p:byte;
begin
 p:=64;
 if portd then inc(p,32);
 PosliPrikaz(p,data);
end;

procedure TUserTester.Tris(portd:boolean;data:byte);
var p:byte;
begin
 p:=64+16;
 if portd then inc(p,32);
 PosliPrikaz(p,data);
end;


function TUserTester.CtiPort(portd:boolean):byte;
var p:byte;
begin
 p:=64;
 if portd then inc(p,32);
 Result:=(Cti(p,true));
end;

//ovladani AD prevodniku
function TUserTester.AD256(nastav:byte):byte;
begin
 Result:=(Cti(nastav+16,true));
end;
function TUserTester.AD1024(nastav:byte):integer;
begin
 Result:=(Cti1024(nastav+16));
end;

//Ovladani 4094
procedure TUserTester.Send4094(str:boolean;data:byte);
var p:byte;
begin
 p:=128;
 if str then inc(p,8);
 PosliPrikaz(p,data);
end;

procedure TUserTester.SendDA(data:byte);
var p:byte;
begin
 p:=144;
 PosliPrikaz(p,data);
end;





procedure TUserTester.SetBase(value:integer);
begin
 a.Init(value);
 lastbase:=value;
end;

procedure TUserTester.About;
begin
 showmessage('Komponenta TUserTester pro obsluhu testeru IO pes I2C. Public domain. Ivo Strasil 2002');
end;

procedure TUserTester.SetWt(value:integer);
begin
 TimeDelay:=value;
end;

function TUserTester.ReadWt:integer;
begin
 Result:=TimeDelay;
end;





procedure Register;
begin
  RegisterComponents('Samples', [TUserTester]);
end;

end.
