	include "p16f874.inc"
;*********************************************
;*   Firmware pro univerzln mc desku   *
;*         verze 1.0 z 18.6.2002             *
;*********************************************
;*  Autor: Ivo Strail                       *
;*  Procesor: PIC16F874                      *
;*  Pozn: WDT OFF, HS 4MHz                   *
;*********************************************


;definice promennych
PRIZNAKY	equ	20h
PRIKAZ		equ	21h
TEMP		equ	22h
SZ_TEMP		equ	23h
CYKL		equ	24h

;definice bitu
#define	I2CLED		porta,5
#define	BUDEPRIKAZ	priznaky,0
#define	BUDELSB		priznaky,1
#define	OUTD		portc,5
#define	OUTCLK		portc,6
#define	OUTSTR		portc,7
#define	DAD		portc,0
#define	DACLK		portc,2
#define	DASTR		portc,1




;*****************************************
;* MAKRA pro prepinani stranek RAM 0/1   *
;*****************************************
bank0	macro
	bcf	status,rp0
	endm	
bank1	macro
 	bsf	status,rp0
	endm	


;*****************************************
;*   ZACATEK programove pameti - skoky   *
;*****************************************


	org	00h
;start programu!
	goto	init
	org	04h
	goto	prerus
;*****************************************
;* Procedure inicializuje I2C jako slave *
;*****************************************
init	movlw	b'00110110'
	movwf	sspcon

	;smaz priznaky
	clrf	PRIZNAKY

	;portc vstup scl sda, zbytek vystupy
	clrf	portc
	movlw	b'00011000'
	tris	portc

	clrf	porta


	movlw	b'11001111'
	tris	porta
	
	
	;banka 1
	bsf	status,rp0
	;adresa
	movlw	b'11001010'	
	movwf	sspadd
	bsf	sspcon2,gcen
	
	;banka 0
	bcf	status,rp0

;***** NASTAVENI AD PREVODNIKU *********
	movlw	b'11000001'
	movwf	adcon0
	
	bank1
	movlw	b'00000100'
	movwf	adcon1
	bank0


;***************************************

;***************************************
	;opakovane cteni sspbuf na portb

start	;nacteme stav I2C/slave
	;a cekame na prerusovaci flag!
	bank0
	btfss	pir1,sspif	;pokud bf=0 tak opakuj
	goto	start
	bcf	pir1,sspif	;nutno SW
	bank1
;*******neco prislo*********************
	;jde o cteni/zapis?
	btfsc	sspstat,I2C_READ
	goto	cteni

;*******jde o zapis*********************
	;otestujeme bity I2C...
	;prisla data???
	btfss	sspstat,5	;data/-adress
	goto	adresa

;*******jsou tam data*******************
	bank0
	;jde o prikaz?
	btfsc	BUDEPRIKAZ
	goto	jeprikaz
;*******neni to prikaz******************
	bcf	BUDEPRIKAZ
	bcf	I2Cled		;zhasnout kontrolku
	;zachovame se podle prikazu...
	;prikaz je v PRIKAZ

	;pozn. je nutno odstranit BF flag prectenim registru...
	movfw	sspbuf

	;jde o 4094?
	btfsc	PRIKAZ,7
	goto	pri4094
	btfsc	PRIKAZ,6
	goto	priIO
	btfsc	PRIKAZ,5
	goto	priSpecIO
	btfsc	PRIKAZ,4
	goto	priAD
	;prikazy zacinajici na 0000 nejsou obslouzeny
	goto	start	

;*******OBSLUHA PRIKAZU: 4094***********
SendZnak	movwf	SZ_TEMP
	movlw	8
	movwf	Cykl
LoopSZ	bcf	OUTD
	rlf	SZ_TEMP,f
	btfsc	STATUS,C
	bsf	OUTD
	bcf	OUTCLK
	nop
	bsf	OUTCLK
	decfsz	Cykl,f
	goto	LoopSZ
	return
SendZnakDA	movwf	SZ_TEMP
	movlw	8
	movwf	Cykl
LoopSZDA	bcf	DAD
	rlf	SZ_TEMP,f
	btfsc	STATUS,C
	bsf	DAD
	bcf	DACLK
	nop
	bsf	DACLK
	decfsz	Cykl,f
	goto	LoopSZDA
	return

Strobe	bcf	OUTSTR
	nop
	bsf	OUTSTR
	nop
	bcf	OUTSTR
	return	
StrobeDA	bcf	DASTR
	nop
	bsf	DASTR
	nop
	bcf	DASTR
	return	


pri4094 ;test: jde o vystup na DA?
	btfsc	prikaz,4
	goto	DAout
EXTout	;odesleme bajt
	movfw	sspbuf
	call	sendznak
	;odesleme i STR?
	btfsc	prikaz,3
	call	strobe
	goto	start

DAout	movfw	sspbuf
	call	sendznakDA
	call	strobeDA

	goto	start

;*******OBSLUHA PRIKAZU: IO  ***********
priIO	;Zjistime subtyp prikazu
   ;O jaky port jde?
	btfsc	prikaz,5
	goto	priIOPD
   ;jde o portB
	movfw	sspbuf

	;jde o tris?
	btfsc	prikaz,4
	bank1
	;predame hodnotu
	movwf	portB	
	;vratime banku [pokud neslo o tris nic se nedeje]
	bank0	
	goto	start

priIOPD	;jde o portD
	movfw	sspbuf

	;jde o tris?
	btfsc	prikaz,4
	bank1		;pozn. vyuziva se stejne abs. adresy PORTx a TRISx
			;[jen jina banka]
	;predame hodnotu
	movwf	portD	
	;vratime banku [pokud neslo o tris nic se nedeje]
	bank0	

	goto	start

;*******OBSLUHA PRIKAZU: SpecIO ********
priSpecIO

	goto	start

;*******OBSLUHA PRIKAZU: AD  ***********
priAD	;nastavime vstupni mux AD prevodniku:
	movfw	prikaz
	andlw	b'00000111'
	movwf	temp
	bcf	status,c
	rlf	temp,f
	rlf	temp,f
	rlf	temp,w
	;hodnota je v bitech 5..3, pridame zbytek
	iorlw	b'11000001'
	;a je to
	movwf	adcon0
	bcf	BUDELSB
	goto	start


jeprikaz
;*******je to prikaz********************
 	bcf	BUDEPRIKAZ
	bcf	BUDELSB
	bcf	I2Cled		;zhasnout kontrolku
	;ulozime do registu PRIKAZ
	movfw	sspbuf
	movwf	PRIKAZ	
	goto	start	




adresa	;je tam adresa
	bank0
	;uvolneni bufferu
	movfw	sspbuf
	;nastaveni priznaku ze prijde prikaz
	bsf	BUDEPRIKAZ
	;indikace
	bsf	I2Cled
	bcf	BUDELSB
	goto	start

ADprevod
	bsf	I2Cled	
	bsf	adcon0,2	;spustime prevod
adp1	btfsc	adcon0,2	;a cekame na jeho ukonceni
	goto	adp1
	nop
	movfw	adresh
	bcf	I2Cled		;zhasnem ledku
	return


cteni	bank0
	bcf	I2Cled		;roznout kontrolku
	bcf	BUDEPRIKAZ
	;ted ziskame data a dame je do bufferu

;*******OK, ted zjistime podle prikazu co se vlastne ma odeslat*******

	btfsc	PRIKAZ,7	;prikaz na 4094
	goto	getERR
	btfsc	PRIKAZ,6	;IO porty
	goto	getIO
	btfsc	PRIKAZ,5	;Specialni IO port
	goto	getERR
	btfsc	PRIKAZ,4	;AD prevodnik
	goto	getAD
	goto	getERR

;*******Odesle do PC hodnotu z AD prevodniku**************************
getAD	;budeme odesilat MSB nebo LSB?
	btfsc	PRIKAZ,3	;pokud se ma odesilat je 8 bitu dej MSB
	goto	getADmsb
	btfsc	BUDELSB		;pokud je priznak LSB, dej LSB
	goto	getADlsb
	;provedeme prevod a odesleme MSB
getADmsb	call	ADprevod
	movwf	sspbuf
	;nastavime priznak pro LSB?
	bsf	BUDELSB
	;data jsou v bufferu
	goto	getOK

getADlsb	;prenese LSB
	bcf	BUDELSB
	bank1
	movfw	adresl
	bank0
	movwf	sspbuf	
	
	goto	getOK
;*******odeslani stavu IO portu*********
getIO	;precteme portb
	movfw	portb
	;mame odeslat portd? tak prepiseme portb.
	btfsc	PRIKAZ,5
	movfw	portd
	movwf	sspbuf	
	goto	getOK	

;*******odeslani kodu 127 jako chyba****
getERR	movlw	.127
	movwf	sspbuf

;*******ceka se na odeslani*************
getOK	bsf	I2CLED
	nop
	;povolime SCL
	bsf	sspcon,ckp	
	;cekej na odeslani
	bank1
cekejcteni	btfsc	sspstat,bf
	goto	cekejcteni
	bank0
	bcf	I2CLED		;zhasnout kontrolku

	goto	start



i2ctoPB	movfw	sspbuf
	movwf	portb
	return	

ctiStat	bsf	status,rp0
	movfw	sspstat
	bcf	status,rp0
	return

prerus	retfie




	end
